Whamcloud - gitweb
Fix bug 2587 - sanity test 56 - so I can pass this on LOV on my system.
[fs/lustre-release.git] / lustre / tests / sanity.sh
1 #!/bin/bash
2 #
3 # Run select tests by setting ONLY, or as arguments to the script.
4 # Skip specific tests by setting EXCEPT.
5 #
6 # e.g. ONLY="22 23" or ONLY="`seq 32 39`" or EXCEPT="31"
7 set -e
8
9 ONLY=${ONLY:-"$*"}
10 # bug number for skipped test: 
11 ALWAYS_EXCEPT=${ALWAYS_EXCEPT:-""}
12 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
13
14 [ "$ALWAYS_EXCEPT$EXCEPT" ] && echo "Skipping tests: $ALWAYS_EXCEPT $EXCEPT"
15
16 SRCDIR=`dirname $0`
17 PATH=$PWD/$SRCDIR:$SRCDIR:$SRCDIR/../utils:$PATH
18
19 TMP=${TMP:-/tmp}
20
21 CHECKSTAT=${CHECKSTAT:-"checkstat -v"}
22 CREATETEST=${CREATETEST:-createtest}
23 LFIND=${LFIND:-lfind}
24 LSTRIPE=${LSTRIPE:-lstripe}
25 LCTL=${LCTL:-lctl}
26 MCREATE=${MCREATE:-mcreate}
27 OPENFILE=${OPENFILE:-openfile}
28 OPENUNLINK=${OPENUNLINK:-openunlink}
29 TOEXCL=${TOEXCL:-toexcl}
30 TRUNCATE=${TRUNCATE:-truncate}
31 MUNLINK=${MUNLINK:-munlink}
32 SOCKETSERVER=${SOCKETSERVER:-socketserver}
33 SOCKETCLIENT=${SOCKETCLIENT:-socketclient}
34 IOPENTEST1=${IOPENTEST1:-iopentest1}
35 IOPENTEST2=${IOPENTEST2:-iopentest2}
36
37 if [ $UID -ne 0 ]; then
38         RUNAS_ID="$UID"
39         RUNAS=""
40 else
41         RUNAS_ID=${RUNAS_ID:-500}
42         RUNAS=${RUNAS:-"runas -u $RUNAS_ID"}
43 fi
44
45 export NAME=${NAME:-local}
46
47 SAVE_PWD=$PWD
48
49 clean() {
50         echo -n "cln.."
51         sh llmountcleanup.sh > /dev/null || exit 20
52         I_MOUNTED=no
53 }
54 CLEAN=${CLEAN:-clean}
55
56 start() {
57         echo -n "mnt.."
58         sh llrmount.sh > /dev/null || exit 10
59         I_MOUNTED=yes
60         echo "done"
61 }
62 START=${START:-start}
63
64 log() {
65         echo "$*"
66         lctl mark "$*" 2> /dev/null || true
67 }
68
69 run_one() {
70         if ! mount | grep -q $DIR; then
71                 $START
72         fi
73         log "== test $1: $2"
74         export TESTNAME=test_$1
75         test_$1 || error "test_$1: exit with rc=$?"
76         unset TESTNAME
77         pass
78         cd $SAVE_PWD
79         $CLEAN
80 }
81
82 build_test_filter() {
83         for O in $ONLY; do
84             eval ONLY_${O}=true
85         done
86         for E in $EXCEPT $ALWAYS_EXCEPT; do
87             eval EXCEPT_${E}=true
88         done
89 }
90
91 _basetest() {
92     echo $*
93 }
94
95 basetest() {
96     IFS=abcdefghijklmnopqrstuvwxyz _basetest $1
97 }
98
99 run_test() {
100          base=`basetest $1`
101          if [ "$ONLY" ]; then
102                  testname=ONLY_$1
103                  if [ ${!testname}x != x ]; then
104                         run_one $1 "$2"
105                         return $?
106                  fi
107                  testname=ONLY_$base
108                  if [ ${!testname}x != x ]; then
109                          run_one $1 "$2"
110                          return $?
111                  fi
112                  echo -n "."
113                  return 0
114         fi
115         testname=EXCEPT_$1
116         if [ ${!testname}x != x ]; then
117                  echo "skipping excluded test $1"
118                  return 0
119         fi
120         testname=EXCEPT_$base
121         if [ ${!testname}x != x ]; then
122                  echo "skipping excluded test $1 (base $base)"
123                  return 0
124         fi
125         run_one $1 "$2"
126         return $?
127 }
128
129 [ "$SANITYLOG" ] && rm -f $SANITYLOG || true
130
131 error() { 
132         log "FAIL: $@"
133         if [ "$SANITYLOG" ]; then
134                 echo "FAIL: $TESTNAME $@" >> $SANITYLOG
135         else
136                 exit 1
137         fi
138 }
139
140 pass() { 
141         echo PASS
142 }
143
144 MOUNT="`mount | awk '/^'$NAME' .* lustre_lite / { print $3 }'`"
145 if [ -z "$MOUNT" ]; then
146         sh llmount.sh
147         MOUNT="`mount | awk '/^'$NAME' .* lustre_lite / { print $3 }'`"
148         [ -z "$MOUNT" ] && error "NAME=$NAME not mounted"
149         I_MOUNTED=yes
150 fi
151
152 [ `echo $MOUNT | wc -w` -gt 1 ] && error "NAME=$NAME mounted more than once"
153
154 DIR=${DIR:-$MOUNT}
155 [ -z "`echo $DIR | grep $MOUNT`" ] && echo "$DIR not in $MOUNT" && exit 99
156
157 LOVNAME=`cat /proc/fs/lustre/llite/fs0/lov/common_name`
158 STRIPECOUNT=`cat /proc/fs/lustre/lov/$LOVNAME/numobd`
159
160 [ -f $DIR/d52a/foo ] && chattr -a $DIR/d52a/foo
161 [ -f $DIR/d52b/foo ] && chattr -i $DIR/d52b/foo
162 rm -rf $DIR/[Rdfs][1-9]*
163
164 build_test_filter
165
166 echo preparing for tests involving mounts
167 EXT2_DEV=${EXT2_DEV:-/tmp/SANITY.LOOP}
168 touch $EXT2_DEV
169 mke2fs -F $EXT2_DEV 1000 > /dev/null
170
171 EXT3_DEV=${EXT3_DEV:-/tmp/SANITY_EXT3_DEV.LOOP}
172 touch $EXT3_DEV
173 mkfs.ext3 -F $EXT3_DEV 10000 > /dev/null
174
175 test_0() {
176         touch $DIR/f
177         $CHECKSTAT -t file $DIR/f || error
178         rm $DIR/f
179         $CHECKSTAT -a $DIR/f || error
180 }
181 run_test 0 "touch .../f ; rm .../f ============================="
182
183 test_1a() {
184         mkdir $DIR/d1
185         mkdir $DIR/d1/d2
186         $CHECKSTAT -t dir $DIR/d1/d2 || error
187 }
188 run_test 1a "mkdir .../d1; mkdir .../d1/d2 ====================="
189
190 test_1b() {
191         rmdir $DIR/d1/d2
192         rmdir $DIR/d1
193         $CHECKSTAT -a $DIR/d1 || error
194 }
195 run_test 1b "rmdir .../d1/d2; rmdir .../d1 ====================="
196
197 test_2a() {
198         mkdir $DIR/d2
199         touch $DIR/d2/f
200         $CHECKSTAT -t file $DIR/d2/f || error
201 }
202 run_test 2a "mkdir .../d2; touch .../d2/f ======================"
203
204 test_2b() {
205         rm -r $DIR/d2
206         $CHECKSTAT -a $DIR/d2 || error
207 }
208 run_test 2b "rm -r .../d2; checkstat .../d2/f ======================"
209
210 test_3a() {
211         mkdir $DIR/d3
212         $CHECKSTAT -t dir $DIR/d3 || error
213 }
214 run_test 3a "mkdir .../d3 ======================================"
215
216 test_3b() {
217         if [ ! -d $DIR/d3 ]; then
218                 mkdir $DIR/d3
219         fi
220         touch $DIR/d3/f
221         $CHECKSTAT -t file $DIR/d3/f || error
222 }
223 run_test 3b "touch .../d3/f ===================================="
224
225 test_3c() {
226         rm -r $DIR/d3
227         $CHECKSTAT -a $DIR/d3 || error
228 }
229 run_test 3c "rm -r .../d3 ======================================"
230
231 test_4a() {
232         mkdir $DIR/d4
233         $CHECKSTAT -t dir $DIR/d4 || error
234 }
235 run_test 4a "mkdir .../d4 ======================================"
236
237 test_4b() {
238         if [ ! -d $DIR/d4 ]; then
239                 mkdir $DIR/d4
240         fi
241         mkdir $DIR/d4/d2
242         $CHECKSTAT -t dir $DIR/d4/d2 || error
243 }
244 run_test 4b "mkdir .../d4/d2 ==================================="
245
246 test_5() {
247         mkdir $DIR/d5
248         mkdir $DIR/d5/d2
249         chmod 0707 $DIR/d5/d2
250         $CHECKSTAT -t dir -p 0707 $DIR/d5/d2 || error
251 }
252 run_test 5 "mkdir .../d5 .../d5/d2; chmod .../d5/d2 ============"
253
254 test_6a() {
255         touch $DIR/f6a
256         chmod 0666 $DIR/f6a || error
257         $CHECKSTAT -t file -p 0666 -u \#$UID $DIR/f6a || error
258 }
259 run_test 6a "touch .../f6a; chmod .../f6a ======================"
260
261 test_6b() {
262         [ $RUNAS_ID -eq $UID ] && echo "skipping test 6b" && return
263         if [ ! -f $DIR/f6a ]; then
264                 touch $DIR/f6a
265                 chmod 0666 $DIR/f6a
266         fi
267         $RUNAS chmod 0444 $DIR/f6a && error
268         $CHECKSTAT -t file -p 0666 -u \#$UID $DIR/f6a || error
269 }
270 run_test 6b "$RUNAS chmod .../f6a (should return error) =="
271
272 test_6c() {
273         [ $RUNAS_ID -eq $UID ] && echo "skipping test 6c" && return
274         touch $DIR/f6c
275         chown $RUNAS_ID $DIR/f6c || error
276         $CHECKSTAT -t file -u \#$RUNAS_ID $DIR/f6c || error
277 }
278 run_test 6c "touch .../f6c; chown .../f6c ======================"
279
280 test_6d() {
281         [ $RUNAS_ID -eq $UID ] && echo "skipping test 6d" && return
282         if [ ! -f $DIR/f6c ]; then
283                 touch $DIR/f6c
284                 chown $RUNAS_ID $DIR/f6c
285         fi
286         $RUNAS chown $UID $DIR/f6c && error
287         $CHECKSTAT -t file -u \#$RUNAS_ID $DIR/f6c || error
288 }
289 run_test 6d "$RUNAS chown .../f6c (should return error) =="
290
291 test_6e() {
292         [ $RUNAS_ID -eq $UID ] && echo "skipping test 6e" && return
293         touch $DIR/f6e
294         chgrp $RUNAS_ID $DIR/f6e || error
295         $CHECKSTAT -t file -u \#$UID -g \#$RUNAS_ID $DIR/f6e || error
296 }
297 run_test 6e "touch .../f6e; chgrp .../f6e ======================"
298
299 test_6f() {
300         [ $RUNAS_ID -eq $UID ] && echo "skipping test 6f" && return
301         if [ ! -f $DIR/f6e ]; then
302                 touch $DIR/f6e
303                 chgrp $RUNAS_ID $DIR/f6e
304         fi
305         $RUNAS chgrp $UID $DIR/f6e && error
306         $CHECKSTAT -t file -u \#$UID -g \#$RUNAS_ID $DIR/f6e || error
307 }
308 run_test 6f "$RUNAS chgrp .../f6e (should return error) =="
309
310 test_6g() {
311         [ $RUNAS_ID -eq $UID ] && echo "skipping test 6g" && return
312         mkdir $DIR/d6g || error
313         chmod 777 $DIR/d6g || error
314         $RUNAS mkdir $DIR/d6g/d || error
315         chmod g+s $DIR/d6g/d || error
316         mkdir $DIR/d6g/d/subdir
317         $CHECKSTAT -g \#$RUNAS_ID $DIR/d6g/d/subdir || error
318 }
319 run_test 6g "Is new dir in sgid dir inheriting group?"
320
321 test_7a() {
322         mkdir $DIR/d7
323         $MCREATE $DIR/d7/f
324         chmod 0666 $DIR/d7/f
325         $CHECKSTAT -t file -p 0666 $DIR/d7/f || error
326 }
327 run_test 7a "mkdir .../d7; mcreate .../d7/f; chmod .../d7/f ===="
328
329 test_7b() {
330         if [ ! -d $DIR/d7 ]; then
331                 mkdir $DIR/d7
332         fi
333         $MCREATE $DIR/d7/f2
334         echo -n foo > $DIR/d7/f2
335         [ "`cat $DIR/d7/f2`" = "foo" ] || error
336         $CHECKSTAT -t file -s 3 $DIR/d7/f2 || error
337 }
338 run_test 7b "mkdir .../d7; mcreate d7/f2; echo foo > d7/f2 ====="
339
340 test_8() {
341         mkdir $DIR/d8
342         touch $DIR/d8/f
343         chmod 0666 $DIR/d8/f
344         $CHECKSTAT -t file -p 0666 $DIR/d8/f || error
345 }
346 run_test 8 "mkdir .../d8; touch .../d8/f; chmod .../d8/f ======="
347
348 test_9() {
349         mkdir $DIR/d9
350         mkdir $DIR/d9/d2
351         mkdir $DIR/d9/d2/d3
352         $CHECKSTAT -t dir $DIR/d9/d2/d3 || error
353 }
354 run_test 9 "mkdir .../d9 .../d9/d2 .../d9/d2/d3 ================"
355
356 test_10() {
357         mkdir $DIR/d10
358         mkdir $DIR/d10/d2
359         touch $DIR/d10/d2/f
360         $CHECKSTAT -t file $DIR/d10/d2/f || error
361 }
362 run_test 10 "mkdir .../d10 .../d10/d2; touch .../d10/d2/f ======"
363
364 test_11() {
365         mkdir $DIR/d11
366         mkdir $DIR/d11/d2
367         chmod 0666 $DIR/d11/d2
368         chmod 0705 $DIR/d11/d2
369         $CHECKSTAT -t dir -p 0705 $DIR/d11/d2 || error
370 }
371 run_test 11 "mkdir .../d11 d11/d2; chmod .../d11/d2 ============"
372
373 test_12() {
374         mkdir $DIR/d12
375         touch $DIR/d12/f
376         chmod 0666 $DIR/d12/f
377         chmod 0654 $DIR/d12/f
378         $CHECKSTAT -t file -p 0654 $DIR/d12/f || error
379 }
380 run_test 12 "touch .../d12/f; chmod .../d12/f .../d12/f ========"
381
382 test_13() {
383         mkdir $DIR/d13
384         dd if=/dev/zero of=$DIR/d13/f count=10
385         >  $DIR/d13/f
386         $CHECKSTAT -t file -s 0 $DIR/d13/f || error
387 }
388 run_test 13 "creat .../d13/f; dd .../d13/f; > .../d13/f ========"
389
390 test_14() {
391         mkdir $DIR/d14
392         touch $DIR/d14/f
393         rm $DIR/d14/f
394         $CHECKSTAT -a $DIR/d14/f || error
395 }
396 run_test 14 "touch .../d14/f; rm .../d14/f; rm .../d14/f ======="
397
398 test_15() {
399         mkdir $DIR/d15
400         touch $DIR/d15/f
401         mv $DIR/d15/f $DIR/d15/f2
402         $CHECKSTAT -t file $DIR/d15/f2 || error
403 }
404 run_test 15 "touch .../d15/f; mv .../d15/f .../d15/f2 =========="
405
406 test_16() {
407         mkdir $DIR/d16
408         touch $DIR/d16/f
409         rm -rf $DIR/d16/f
410         $CHECKSTAT -a $DIR/d16/f || error
411 }
412 run_test 16 "touch .../d16/f; rm -rf .../d16/f ================="
413
414 test_17a() {
415         mkdir $DIR/d17
416         touch $DIR/d17/f
417         ln -s $DIR/d17/f $DIR/d17/l-exist
418         ls -l $DIR/d17
419         $CHECKSTAT -l $DIR/d17/f $DIR/d17/l-exist || error
420         $CHECKSTAT -f -t f $DIR/d17/l-exist || error
421         rm -f $DIR/l-exist
422         $CHECKSTAT -a $DIR/l-exist || error
423 }
424 run_test 17a "symlinks: create, remove (real) =================="
425
426 test_17b() {
427         if [ ! -d $DIR/d17 ]; then
428                 mkdir $DIR/d17
429         fi
430         ln -s no-such-file $DIR/d17/l-dangle
431         ls -l $DIR/d17
432         $CHECKSTAT -l no-such-file $DIR/d17/l-dangle || error
433         $CHECKSTAT -fa $DIR/d17/l-dangle || error
434         rm -f $DIR/l-dangle
435         $CHECKSTAT -a $DIR/l-dangle || error
436 }
437 run_test 17b "symlinks: create, remove (dangling) =============="
438
439 test_18() {
440         touch $DIR/f
441         ls $DIR || error
442 }
443 run_test 18 "touch .../f ; ls ... =============================="
444
445 test_19a() {
446         touch $DIR/f19
447         ls -l $DIR
448         rm $DIR/f19
449         $CHECKSTAT -a $DIR/f19 || error
450 }
451 run_test 19a "touch .../f19 ; ls -l ... ; rm .../f19 ==========="
452
453 test_19b() {
454         ls -l $DIR/f19 && error || true
455 }
456 run_test 19b "ls -l .../f19 (should return error) =============="
457
458 test_19c() {
459         [ $RUNAS_ID -eq $UID ] && echo "skipping test 19c" && return
460         $RUNAS touch $DIR/f19 && error || true
461 }
462 run_test 19c "$RUNAS touch .../f19 (should return error) =="
463
464 test_19d() {
465         cat $DIR/f19 && error || true
466 }
467 run_test 19d "cat .../f19 (should return error) =============="
468
469 test_20() {
470         touch $DIR/f
471         rm $DIR/f
472         log "1 done"
473         touch $DIR/f
474         rm $DIR/f
475         log "2 done"
476         touch $DIR/f
477         rm $DIR/f
478         log "3 done"
479         $CHECKSTAT -a $DIR/f || error
480 }
481 run_test 20 "touch .../f ; ls -l ... ==========================="
482
483 test_21() {
484         mkdir $DIR/d21
485         [ -f $DIR/d21/dangle ] && rm -f $DIR/d21/dangle
486         ln -s dangle $DIR/d21/link
487         echo foo >> $DIR/d21/link
488         cat $DIR/d21/dangle
489         $CHECKSTAT -t link $DIR/d21/link || error
490         $CHECKSTAT -f -t file $DIR/d21/link || error
491 }
492 run_test 21 "write to dangling link ============================"
493
494 test_22() {
495         mkdir $DIR/d22
496         chown $RUNAS_ID $DIR/d22
497         # Tar gets pissy if it can't access $PWD *sigh*
498         (cd /tmp;
499         $RUNAS tar cf - /etc/hosts /etc/sysconfig/network | \
500         $RUNAS tar xfC - $DIR/d22)
501         ls -lR $DIR/d22/etc
502         $CHECKSTAT -t dir $DIR/d22/etc || error
503         $CHECKSTAT -u \#$RUNAS_ID $DIR/d22/etc || error
504 }
505 run_test 22 "unpack tar archive as non-root user ==============="
506
507 test_23() {
508         mkdir $DIR/d23
509         $TOEXCL $DIR/d23/f23
510         $TOEXCL -e $DIR/d23/f23 || error
511 }
512 run_test 23 "O_CREAT|O_EXCL in subdir =========================="
513
514 test_24a() {
515         echo '== rename sanity =============================================='
516         echo '-- same directory rename'
517         mkdir $DIR/R1
518         touch $DIR/R1/f
519         mv $DIR/R1/f $DIR/R1/g
520         $CHECKSTAT -t file $DIR/R1/g || error
521 }
522 run_test 24a "touch .../R1/f; rename .../R1/f .../R1/g ========="
523
524 test_24b() {
525         mkdir $DIR/R2
526         touch $DIR/R2/{f,g}
527         mv $DIR/R2/f $DIR/R2/g
528         $CHECKSTAT -a $DIR/R2/f || error
529         $CHECKSTAT -t file $DIR/R2/g || error
530 }
531 run_test 24b "touch .../R2/{f,g}; rename .../R2/f .../R2/g ====="
532
533 test_24c() {
534         mkdir $DIR/R3
535         mkdir $DIR/R3/f
536         mv $DIR/R3/f $DIR/R3/g
537         $CHECKSTAT -a $DIR/R3/f || error
538         $CHECKSTAT -t dir $DIR/R3/g || error
539 }
540 run_test 24c "mkdir .../R3/f; rename .../R3/f .../R3/g ========="
541
542 test_24d() {
543         mkdir $DIR/R4
544         mkdir $DIR/R4/{f,g}
545         perl -e "rename \"$DIR/R4/f\", \"$DIR/R4/g\";"
546         $CHECKSTAT -a $DIR/R4/f || error
547         $CHECKSTAT -t dir $DIR/R4/g || error
548 }
549 run_test 24d "mkdir .../R4/{f,g}; rename .../R4/f .../R4/g ====="
550
551 test_24e() {
552         echo '-- cross directory renames --' 
553         mkdir $DIR/R5{a,b}
554         touch $DIR/R5a/f
555         mv $DIR/R5a/f $DIR/R5b/g
556         $CHECKSTAT -a $DIR/R5a/f || error
557         $CHECKSTAT -t file $DIR/R5b/g || error
558 }
559 run_test 24e "touch .../R5a/f; rename .../R5a/f .../R5b/g ======"
560
561 test_24f() {
562         mkdir $DIR/R6{a,b}
563         touch $DIR/R6a/f $DIR/R6b/g
564         mv $DIR/R6a/f $DIR/R6b/g
565         $CHECKSTAT -a $DIR/R6a/f || error
566         $CHECKSTAT -t file $DIR/R6b/g || error
567 }
568 run_test 24f "touch .../R6a/f R6b/g; mv .../R6a/f .../R6b/g ===="
569
570 test_24g() {
571         mkdir $DIR/R7{a,b}
572         mkdir $DIR/R7a/d
573         mv $DIR/R7a/d $DIR/R7b/e
574         $CHECKSTAT -a $DIR/R7a/d || error
575         $CHECKSTAT -t dir $DIR/R7b/e || error
576 }
577 run_test 24g "mkdir .../R7a/d; rename .../R7a/d .../R5b/e ======"
578
579 test_24h() {
580         mkdir $DIR/R8{a,b}
581         mkdir $DIR/R8a/d $DIR/R8b/e
582         perl -e "rename \"$DIR/R8a/d\", \"$DIR/R8b/e\";"
583         $CHECKSTAT -a $DIR/R8a/d || error
584         $CHECKSTAT -t dir $DIR/R8b/e || error
585 }
586 run_test 24h "mkdir .../R8{a,b} R8a/{d,e}; mv .../R8a/d .../R8b/e"
587
588 test_24i() {
589         echo "-- rename error cases"
590         mkdir $DIR/R9
591         mkdir $DIR/R9/a
592         touch $DIR/R9/f
593         perl -e "rename \"$DIR/R9/f\", \"$DIR/R9/a\";"
594         $CHECKSTAT -t file $DIR/R9/f || error
595         $CHECKSTAT -t dir  $DIR/R9/a || error
596         $CHECKSTAT -a file $DIR/R9/a/f || error
597 }
598 run_test 24i "rename file to dir error: touch f ; mkdir a ; rename f a"
599
600 test_24j() {
601         mkdir $DIR/R10
602         perl -e "rename \"$DIR/R10/f\", \"$DIR/R10/g\"" 
603         $CHECKSTAT -t dir $DIR/R10 || error
604         $CHECKSTAT -a $DIR/R10/f || error
605         $CHECKSTAT -a $DIR/R10/g || error
606 }
607 run_test 24j "source does not exist ============================" 
608
609 test_24k() {
610         mkdir $DIR/R11a $DIR/R11a/d
611         touch $DIR/R11a/f
612         mv $DIR/R11a/f $DIR/R11a/d
613         $CHECKSTAT -a $DIR/R11a/f || error
614         $CHECKSTAT -t file $DIR/R11a/d/f || error
615 }
616 run_test 24k "touch .../R11a/f; mv .../R11a/f .../R11a/d ======="
617
618 # bug 2429 - rename foo foo foo creates invalid file
619 test_24l() {
620         f="$DIR/f24l"
621         multiop $f OcNs || error
622 }
623 run_test 24l "Renaming a file to itself ========================"
624
625 test_24m() {
626         f="$DIR/f24m"
627         multiop $f OcLN ${f}2 ${f}2 || error
628 }
629 run_test 24m "Renaming a file to a hard link to itself ========="
630
631 test_25a() {
632         echo '== symlink sanity ============================================='
633         mkdir $DIR/d25
634         ln -s d25 $DIR/s25
635         touch $DIR/s25/foo || error
636 }
637 run_test 25a "create file in symlinked directory ==============="
638
639 test_25b() {
640         if [ ! -d $DIR/d25 ]; then
641                 run_one 25a
642         fi
643         $CHECKSTAT -t file $DIR/s25/foo || error
644 }
645 run_test 25b "lookup file in symlinked directory ==============="
646
647 test_26a() {
648         mkdir $DIR/d26
649         mkdir $DIR/d26/d26-2
650         ln -s d26/d26-2 $DIR/s26
651         touch $DIR/s26/foo || error
652 }
653 run_test 26a "multiple component symlink ======================="
654
655 test_26b() {
656         mkdir -p $DIR/d26b/d26-2
657         ln -s d26b/d26-2/foo $DIR/s26-2
658         touch $DIR/s26-2 || error
659 }
660 run_test 26b "multiple component symlink at end of lookup ======"
661
662 test_26c() {
663         mkdir $DIR/d26.2
664         touch $DIR/d26.2/foo
665         ln -s d26.2 $DIR/s26.2-1
666         ln -s s26.2-1 $DIR/s26.2-2
667         ln -s s26.2-2 $DIR/s26.2-3
668         chmod 0666 $DIR/s26.2-3/foo
669 }
670 run_test 26c "chain of symlinks ================================"
671
672 # recursive symlinks (bug 439)
673 test_26d() {
674         ln -s d26-3/foo $DIR/d26-3
675 }
676 run_test 26d "create multiple component recursive symlink ======"
677
678 test_26e() {
679         if [ ! -h $DIR/d26-3 ]; then
680                 run_one 26d
681         fi
682         rm $DIR/d26-3
683 }
684 run_test 26e "unlink multiple component recursive symlink ======"
685
686 test_27a() {
687         echo '== stripe sanity =============================================='
688         mkdir $DIR/d27
689         $LSTRIPE $DIR/d27/f0 8192 0 1 || error
690         $CHECKSTAT -t file $DIR/d27/f0 || error
691         pass
692         log "== test_27b: write to one stripe file ========================="
693         cp /etc/hosts $DIR/d27/f0 || error
694 }
695 run_test 27a "one stripe file =================================="
696
697 test_27c() {
698         [ "$STRIPECOUNT" -lt "2" ] && echo "skipping 2-stripe test" && return
699         if [ ! -d $DIR/d27 ]; then
700                 mkdir $DIR/d27
701         fi
702         $LSTRIPE $DIR/d27/f01 8192 0 2 || error
703         [ `$LFIND $DIR/d27/f01 | grep -A 10 obdidx | wc -l` -eq 4 ] ||
704                 error "two-stripe file doesn't have two stripes"
705         pass
706         log "== test_27d: write to two stripe file file f01 ================"
707         dd if=/dev/zero of=$DIR/d27/f01 bs=4k count=4 || error
708 }
709 run_test 27c "create two stripe file f01 ======================="
710
711 test_27d() {
712         if [ ! -d $DIR/d27 ]; then
713                 mkdir $DIR/d27
714         fi
715         $LSTRIPE $DIR/d27/fdef 0 -1 0 || error
716         $CHECKSTAT -t file $DIR/d27/fdef || error
717         #dd if=/dev/zero of=$DIR/d27/fdef bs=4k count=4 || error
718 }
719 run_test 27d "create file with default settings ================"
720
721 test_27e() {
722         if [ ! -d $DIR/d27 ]; then
723                 mkdir $DIR/d27
724         fi
725         $LSTRIPE $DIR/d27/f12 8192 0 2 || error
726         $LSTRIPE $DIR/d27/f12 8192 0 2 && error
727         $CHECKSTAT -t file $DIR/d27/f12 || error
728 }
729 run_test 27e "lstripe existing file (should return error) ======"
730
731 test_27f() {
732         if [ ! -d $DIR/d27 ]; then
733                 mkdir $DIR/d27
734         fi
735         $LSTRIPE $DIR/d27/fbad 100 0 1 && error
736         dd if=/dev/zero of=$DIR/d27/f12 bs=4k count=4 || error
737         $LFIND $DIR/d27/fbad || error
738 }
739 run_test 27f "lstripe with bad stripe size (should return error)"
740
741 test_27g() {
742         if [ ! -d $DIR/d27 ]; then
743                 mkdir $DIR/d27
744         fi
745         $MCREATE $DIR/d27/fnone || error
746         pass
747         log "== test 27h: lfind with no objects ============================"
748         $LFIND $DIR/d27/fnone 2>&1 | grep -q "no stripe info" || error
749         pass
750         log "== test 27i: lfind with some objects =========================="
751         touch $DIR/d27/fsome || error
752         $LFIND $DIR/d27/fsome | grep -q obdidx || error
753 }
754 run_test 27g "test lfind ======================================="
755
756 test_27j() {
757         if [ ! -d $DIR/d27 ]; then
758                 mkdir $DIR/d27
759         fi
760         $LSTRIPE $DIR/d27/f27j 8192 $STRIPECOUNT 1 && error || true
761 }
762 run_test 27j "lstripe with bad stripe offset (should return error)"
763
764 test_28() {
765         mkdir $DIR/d28
766         $CREATETEST $DIR/d28/ct || error
767 }
768 run_test 28 "create/mknod/mkdir with bad file types ============"
769
770 cancel_lru_locks() {
771         for d in /proc/fs/lustre/ldlm/namespaces/$1*; do
772                 echo clear > $d/lru_size
773         done
774         grep [0-9] /proc/fs/lustre/ldlm/namespaces/$1*/lock_unused_count /dev/null
775 }
776
777 test_29() {
778         cancel_lru_locks MDC
779         mkdir $DIR/d29
780         touch $DIR/d29/foo
781         log 'first d29'
782         ls -l $DIR/d29
783         MDCDIR=${MDCDIR:-/proc/fs/lustre/ldlm/namespaces/MDC_*}
784         LOCKCOUNTORIG=`cat $MDCDIR/lock_count`
785         LOCKUNUSEDCOUNTORIG=`cat $MDCDIR/lock_unused_count`
786         log 'second d29'
787         ls -l $DIR/d29
788         log 'done'
789         LOCKCOUNTCURRENT=`cat $MDCDIR/lock_count`
790         LOCKUNUSEDCOUNTCURRENT=`cat $MDCDIR/lock_unused_count`
791         if [ $LOCKCOUNTCURRENT -gt $LOCKCOUNTORIG ]; then
792                 echo "CURRENT: $LOCKCOUNTCURRENT > $LOCKCOUNTORIG"
793                 error
794         fi
795         if [ $LOCKUNUSEDCOUNTCURRENT -gt $LOCKUNUSEDCOUNTORIG ]; then
796                 echo "UNUSED: $LOCKUNUSEDCOUNTCURRENT > $LOCKUNUSEDCOUNTORIG"
797                 error
798         fi
799 }
800 run_test 29 "IT_GETATTR regression  ============================"
801
802 test_30() {
803         cp `which ls` $DIR
804         $DIR/ls /
805         rm $DIR/ls
806 }
807 run_test 30 "run binary from Lustre (execve) ==================="
808
809 test_31a() {
810         $OPENUNLINK $DIR/f31 $DIR/f31 || error
811         $CHECKSTAT -a $DIR/f31 || error
812 }
813 run_test 31a "open-unlink file =================================="
814
815 test_31b() {
816         touch $DIR/f31 || error
817         ln $DIR/f31 $DIR/f31b || error
818         multiop $DIR/f31b Ouc || error
819         $CHECKSTAT -t file $DIR/f31 || error
820 }
821 run_test 31b "unlink file with multiple links while open ======="
822
823 test_31c() {
824         touch $DIR/f31 || error
825         ln $DIR/f31 $DIR/f31c || error
826         multiop $DIR/f31 O_uc &
827         MULTIPID=$!
828         multiop $DIR/f31c Ouc
829         usleep 500
830         kill -USR1 $MULTIPID
831         wait $MUTLIPID
832 }
833 run_test 31c "open-unlink file with multiple links ============="
834
835 test_31d() {
836         opendirunlink $DIR/d31d $DIR/d31d || error
837         $CHECKSTAT -a $DIR/d31d || error
838 }
839 run_test 31d "remove of open directory ========================="
840
841 test_32a() {
842         echo "== more mountpoints and symlinks ================="
843         [ -e $DIR/d32a ] && rm -fr $DIR/d32a
844         mkdir -p $DIR/d32a/ext2-mountpoint 
845         mount -t ext2 -o loop $EXT2_DEV $DIR/d32a/ext2-mountpoint || error
846         $CHECKSTAT -t dir $DIR/d32a/ext2-mountpoint/.. || error  
847         umount $DIR/d32a/ext2-mountpoint || error
848 }
849 run_test 32a "stat d32a/ext2-mountpoint/.. ====================="
850
851 test_32b() {
852         [ -e $DIR/d32b ] && rm -fr $DIR/d32b
853         mkdir -p $DIR/d32b/ext2-mountpoint 
854         mount -t ext2 -o loop $EXT2_DEV $DIR/d32b/ext2-mountpoint || error
855         ls -al $DIR/d32b/ext2-mountpoint/.. || error
856         umount $DIR/d32b/ext2-mountpoint || error
857 }
858 run_test 32b "open d32b/ext2-mountpoint/.. ====================="
859  
860 test_32c() {
861         [ -e $DIR/d32c ] && rm -fr $DIR/d32c
862         mkdir -p $DIR/d32c/ext2-mountpoint 
863         mount -t ext2 -o loop $EXT2_DEV $DIR/d32c/ext2-mountpoint || error
864         mkdir -p $DIR/d32c/d2/test_dir    
865         $CHECKSTAT -t dir $DIR/d32c/ext2-mountpoint/../d2/test_dir || error
866         umount $DIR/d32c/ext2-mountpoint || error
867 }
868 run_test 32c "stat d32c/ext2-mountpoint/../d2/test_dir ========="
869
870 test_32d() {
871         [ -e $DIR/d32d ] && rm -fr $DIR/d32d
872         mkdir -p $DIR/d32d/ext2-mountpoint 
873         mount -t ext2 -o loop $EXT2_DEV $DIR/d32d/ext2-mountpoint || error
874         mkdir -p $DIR/d32d/d2/test_dir    
875         ls -al $DIR/d32d/ext2-mountpoint/../d2/test_dir || error
876         umount $DIR/d32d/ext2-mountpoint || error
877 }
878 run_test 32d "open d32d/ext2-mountpoint/../d2/test_dir ========="
879
880 test_32e() {
881         [ -e $DIR/d32e ] && rm -fr $DIR/d32e
882         mkdir -p $DIR/d32e/tmp    
883         TMP_DIR=$DIR/d32e/tmp       
884         ln -s $DIR/d32e $TMP_DIR/symlink11 
885         ln -s $TMP_DIR/symlink11 $TMP_DIR/../symlink01 
886         $CHECKSTAT -t link $DIR/d32e/tmp/symlink11 || error
887         $CHECKSTAT -t link $DIR/d32e/symlink01 || error
888 }
889 run_test 32e "stat d32e/symlink->tmp/symlink->lustre-subdir ===="
890
891 test_32f() {
892         [ -e $DIR/d32f ] && rm -fr $DIR/d32f
893         mkdir -p $DIR/d32f/tmp    
894         TMP_DIR=$DIR/d32f/tmp       
895         ln -s $DIR/d32f $TMP_DIR/symlink11 
896         ln -s $TMP_DIR/symlink11 $TMP_DIR/../symlink01 
897         ls $DIR/d32f/tmp/symlink11  || error
898         ls $DIR/d32f/symlink01 || error
899 }
900 run_test 32f "open d32f/symlink->tmp/symlink->lustre-subdir ===="
901
902 test_32g() {
903         [ -e $DIR/d32g ] && rm -fr $DIR/d32g
904         [ -e $DIR/test_dir ] && rm -fr $DIR/test_dir
905         mkdir -p $DIR/test_dir 
906         mkdir -p $DIR/d32g/tmp    
907         TMP_DIR=$DIR/d32g/tmp       
908         ln -s $DIR/test_dir $TMP_DIR/symlink12 
909         ln -s $TMP_DIR/symlink12 $TMP_DIR/../symlink02 
910         $CHECKSTAT -t link $DIR/d32g/tmp/symlink12 || error
911         $CHECKSTAT -t link $DIR/d32g/symlink02 || error
912         $CHECKSTAT -t dir -f $DIR/d32g/tmp/symlink12 || error
913         $CHECKSTAT -t dir -f $DIR/d32g/symlink02 || error
914 }
915 run_test 32g "stat d32g/symlink->tmp/symlink->lustre-subdir/test_dir"
916
917 test_32h() {
918         [ -e $DIR/d32h ] && rm -fr $DIR/d32h
919         [ -e $DIR/test_dir ] && rm -fr $DIR/test_dir
920         mkdir -p $DIR/test_dir 
921         mkdir -p $DIR/d32h/tmp    
922         TMP_DIR=$DIR/d32h/tmp       
923         ln -s $DIR/test_dir $TMP_DIR/symlink12 
924         ln -s $TMP_DIR/symlink12 $TMP_DIR/../symlink02 
925         ls $DIR/d32h/tmp/symlink12 || error
926         ls $DIR/d32h/symlink02  || error
927 }
928 run_test 32h "open d32h/symlink->tmp/symlink->lustre-subdir/test_dir"
929
930 test_32i() {
931         [ -e $DIR/d32i ] && rm -fr $DIR/d32i
932         mkdir -p $DIR/d32i/ext2-mountpoint 
933         mount -t ext2 -o loop $EXT2_DEV $DIR/d32i/ext2-mountpoint || error
934         touch $DIR/d32i/test_file
935         $CHECKSTAT -t file $DIR/d32i/ext2-mountpoint/../test_file || error  
936         umount $DIR/d32i/ext2-mountpoint || error
937 }
938 run_test 32i "stat d32i/ext2-mountpoint/../test_file ==========="
939
940 test_32j() {
941         [ -e $DIR/d32j ] && rm -fr $DIR/d32j
942         mkdir -p $DIR/d32j/ext2-mountpoint 
943         mount -t ext2 -o loop $EXT2_DEV $DIR/d32j/ext2-mountpoint || error
944         touch $DIR/d32j/test_file
945         cat $DIR/d32j/ext2-mountpoint/../test_file || error
946         umount $DIR/d32j/ext2-mountpoint || error
947 }
948 run_test 32j "open d32j/ext2-mountpoint/../test_file ==========="
949
950 test_32k() {
951         rm -fr $DIR/d32k
952         mkdir -p $DIR/d32k/ext2-mountpoint 
953         mount -t ext2 -o loop $EXT2_DEV $DIR/d32k/ext2-mountpoint  
954         mkdir -p $DIR/d32k/d2
955         touch $DIR/d32k/d2/test_file || error
956         $CHECKSTAT -t file $DIR/d32k/ext2-mountpoint/../d2/test_file || error
957         umount $DIR/d32k/ext2-mountpoint || error
958 }
959 run_test 32k "stat d32k/ext2-mountpoint/../d2/test_file ========"
960
961 test_32l() {
962         rm -fr $DIR/d32l
963         mkdir -p $DIR/d32l/ext2-mountpoint 
964         mount -t ext2 -o loop $EXT2_DEV $DIR/d32l/ext2-mountpoint || error
965         mkdir -p $DIR/d32l/d2
966         touch $DIR/d32l/d2/test_file
967         cat  $DIR/d32l/ext2-mountpoint/../d2/test_file || error
968         umount $DIR/d32l/ext2-mountpoint || error
969 }
970 run_test 32l "open d32l/ext2-mountpoint/../d2/test_file ========"
971
972 test_32m() {
973         rm -fr $DIR/d32m
974         mkdir -p $DIR/d32m/tmp    
975         TMP_DIR=$DIR/d32m/tmp       
976         ln -s $DIR $TMP_DIR/symlink11 
977         ln -s $TMP_DIR/symlink11 $TMP_DIR/../symlink01 
978         $CHECKSTAT -t link $DIR/d32m/tmp/symlink11 || error
979         $CHECKSTAT -t link $DIR/d32m/symlink01 || error
980 }
981 run_test 32m "stat d32m/symlink->tmp/symlink->lustre-root ======"
982
983 test_32n() {
984         rm -fr $DIR/d32n
985         mkdir -p $DIR/d32n/tmp    
986         TMP_DIR=$DIR/d32n/tmp       
987         ln -s $DIR $TMP_DIR/symlink11 
988         ln -s $TMP_DIR/symlink11 $TMP_DIR/../symlink01 
989         ls -l $DIR/d32n/tmp/symlink11  || error
990         ls -l $DIR/d32n/symlink01 || error
991 }
992 run_test 32n "open d32n/symlink->tmp/symlink->lustre-root ======"
993
994 test_32o() {
995         rm -fr $DIR/d32o
996         rm -f $DIR/test_file
997         touch $DIR/test_file 
998         mkdir -p $DIR/d32o/tmp    
999         TMP_DIR=$DIR/d32o/tmp       
1000         ln -s $DIR/test_file $TMP_DIR/symlink12 
1001         ln -s $TMP_DIR/symlink12 $TMP_DIR/../symlink02 
1002         $CHECKSTAT -t link $DIR/d32o/tmp/symlink12 || error
1003         $CHECKSTAT -t link $DIR/d32o/symlink02 || error
1004         $CHECKSTAT -t file -f $DIR/d32o/tmp/symlink12 || error
1005         $CHECKSTAT -t file -f $DIR/d32o/symlink02 || error
1006 }
1007 run_test 32o "stat d32o/symlink->tmp/symlink->lustre-root/test_file"
1008
1009 test_32p() {
1010     log 32p_1
1011         rm -fr $DIR/d32p
1012     log 32p_2
1013         rm -f $DIR/test_file
1014     log 32p_3
1015         touch $DIR/test_file 
1016     log 32p_4
1017         mkdir -p $DIR/d32p/tmp    
1018     log 32p_5
1019         TMP_DIR=$DIR/d32p/tmp       
1020     log 32p_6
1021         ln -s $DIR/test_file $TMP_DIR/symlink12 
1022     log 32p_7
1023         ln -s $TMP_DIR/symlink12 $TMP_DIR/../symlink02 
1024     log 32p_8
1025         cat $DIR/d32p/tmp/symlink12 || error
1026     log 32p_9
1027         cat $DIR/d32p/symlink02 || error
1028     log 32p_10
1029 }
1030 run_test 32p "open d32p/symlink->tmp/symlink->lustre-root/test_file"
1031
1032 test_32q() {
1033         [ -e $DIR/d32q ] && rm -fr $DIR/d32q
1034         mkdir -p $DIR/d32q
1035         touch $DIR/d32q/under_the_mount
1036         mount -t ext2 -o loop $EXT2_DEV $DIR/d32q
1037         ls $DIR/d32q/under_the_mount &&  error || true
1038         umount $DIR/d32q || error
1039 }
1040 run_test 32q "stat follows mountpoints in Lustre ========================="
1041
1042 test_32r() {
1043         [ -e $DIR/d32r ] && rm -fr $DIR/d32r
1044         mkdir -p $DIR/d32r
1045         touch $DIR/d32r/under_the_mount
1046         mount -t ext2 -o loop $EXT2_DEV $DIR/d32r
1047         ls $DIR/d32r | grep -q under_the_mount &&  error || true
1048         umount $DIR/d32r || error
1049 }
1050 run_test 32r "opendir follows mountpoints in Lustre ========================="
1051
1052 #   chmod 444 /mnt/lustre/somefile
1053 #   open(/mnt/lustre/somefile, O_RDWR)
1054 #   Should return -1
1055 test_33() {
1056         rm -f $DIR/test_33_file
1057         touch $DIR/test_33_file
1058         chmod 444 $DIR/test_33_file
1059         chown $RUNAS_ID $DIR/test_33_file
1060         log 33_1
1061         $RUNAS $OPENFILE -f O_RDWR $DIR/test_33_file && error || true
1062         log 33_2
1063 }
1064 run_test 33 "write file with mode 444 (should return error) ===="
1065                                                                                                                                                
1066 test_33a() {
1067         rm -fr $DIR/d33
1068         mkdir -p $DIR/d33
1069         chown $RUNAS_ID $DIR/d33
1070         $RUNAS $OPENFILE -f O_RDWR:O_CREAT -m 0444 $DIR/d33/f33 || error
1071         $RUNAS $OPENFILE -f O_RDWR:O_CREAT -m 0444 $DIR/d33/f33 && error || true
1072 }
1073 run_test 33a "test open file(mode=0444) with O_RDWR (should return error) ===="
1074
1075 TEST_34_SIZE=${TEST_34_SIZE:-2000000000000}
1076 test_34a() {
1077         rm -f $DIR/test_34_file
1078         $MCREATE $DIR/test_34_file || error
1079         $LFIND $DIR/test_34_file 2>&1 | grep -q "no stripe info" || error
1080         $TRUNCATE $DIR/test_34_file $TEST_34_SIZE || error
1081         $LFIND $DIR/test_34_file 2>&1 | grep -q "no stripe info" || error
1082         $CHECKSTAT -s $TEST_34_SIZE $DIR/test_34_file || error
1083 }
1084 run_test 34a "truncate file that has not been opened ==========="
1085
1086 test_34b() {
1087         [ ! -f $DIR/test_34_file ] && run_one 34a
1088         $CHECKSTAT -s $TEST_34_SIZE $DIR/test_34_file || error
1089         $OPENFILE -f O_RDONLY $DIR/test_34_file
1090         $LFIND $DIR/test_34_file 2>&1 | grep -q "no stripe info" || error
1091         $CHECKSTAT -s $TEST_34_SIZE $DIR/test_34_file || error
1092 }
1093 run_test 34b "O_RDONLY opening file doesn't create objects ====="
1094
1095 test_34c() {
1096         [ ! -f $DIR/test_34_file ] && run_one 34a 
1097         $CHECKSTAT -s $TEST_34_SIZE $DIR/test_34_file || error
1098         $OPENFILE -f O_RDWR $DIR/test_34_file
1099         $LFIND $DIR/test_34_file 2>&1 | grep -q "no stripe info" && error
1100         $CHECKSTAT -s $TEST_34_SIZE $DIR/test_34_file || error
1101 }
1102 run_test 34c "O_RDWR opening file-with-size works =============="
1103
1104 test_34d() {
1105         dd if=/dev/zero of=$DIR/test_34_file conv=notrunc bs=4k count=1 || error
1106         $CHECKSTAT -s $TEST_34_SIZE $DIR/test_34_file || error
1107         rm $DIR/test_34_file
1108 }
1109 run_test 34d "write to sparse file ============================="
1110
1111 test_34e() {
1112         rm -f $DIR/test_34_file
1113         $MCREATE $DIR/test_34_file || error
1114         $TRUNCATE $DIR/test_34_file 1000 || error
1115         $CHECKSTAT -s 1000 $DIR/test_34_file || error
1116         $OPENFILE -f O_RDWR $DIR/test_34_file
1117         $CHECKSTAT -s 1000 $DIR/test_34_file || error
1118 }
1119 run_test 34e "create objects, some with size and some without =="
1120
1121 test_35a() {
1122         cp /bin/sh $DIR/test_35a_file
1123         chmod 444 $DIR/test_35a_file
1124         chown $RUNAS_ID $DIR/test_35a_file
1125         $RUNAS $DIR/test_35a_file && error || true
1126         rm $DIR/test_35a_file
1127 }
1128 run_test 35a "exec file with mode 444 (should return and not leak) ====="
1129
1130
1131 test_36a() {
1132         rm -f $DIR/test_36_file
1133         utime $DIR/test_36_file || error
1134 }
1135 run_test 36a "MDS utime check (mknod, utime) ==================="
1136
1137 test_36b() {
1138         echo "" > $DIR/test_36_file
1139         utime $DIR/test_36_file || error
1140 }
1141 run_test 36b "OST utime check (open, utime) ===================="
1142
1143 test_36c() {
1144         rm -f $DIR/d36/test_36_file
1145         mkdir $DIR/d36
1146         chown $RUNAS_ID $DIR/d36
1147         $RUNAS utime $DIR/d36/test_36_file || error
1148 }
1149 run_test 36c "non-root MDS utime check (mknod, utime) =========="
1150
1151 test_36d() {
1152         [ ! -d $DIR/d36 ] && run_one 36c
1153         echo "" > $DIR/d36/test_36_file
1154         $RUNAS utime $DIR/d36/test_36_file || error
1155 }
1156 run_test 36d "non-root OST utime check (open, utime) ==========="
1157
1158 test_36e() {
1159         [ $RUNAS_ID -eq $UID ] && return
1160         [ ! -d $DIR/d36 ] && mkdir $DIR/d36
1161         touch $DIR/d36/test_36_file2
1162         $RUNAS utime $DIR/d36/test_36_file2 && error || true
1163 }
1164 run_test 36e "utime on non-owned file (should return error) ===="
1165
1166 test_37() {
1167         mkdir -p $DIR/dextra
1168         echo f > $DIR/dextra/fbugfile
1169         mount -t ext2 -o loop $EXT2_DEV $DIR/dextra
1170         ls $DIR/dextra | grep "\<fbugfile\>" && error
1171         umount $DIR/dextra || error
1172         rm -f $DIR/dextra/fbugfile || error
1173 }
1174 run_test 37 "ls a mounted file system to check old content ====="
1175
1176 test_38() {
1177         o_directory $DIR/test38
1178 }
1179 run_test 38 "open a regular file with O_DIRECTORY =============="
1180
1181 test_39() {
1182         touch $DIR/test_39_file
1183         touch $DIR/test_39_file2
1184 #       ls -l  $DIR/test_39_file $DIR/test_39_file2
1185 #       ls -lu  $DIR/test_39_file $DIR/test_39_file2
1186 #       ls -lc  $DIR/test_39_file $DIR/test_39_file2
1187         sleep 2
1188         $OPENFILE -f O_CREAT:O_TRUNC:O_WRONLY $DIR/test_39_file2
1189 #       ls -l  $DIR/test_39_file $DIR/test_39_file2
1190 #       ls -lu  $DIR/test_39_file $DIR/test_39_file2
1191 #       ls -lc  $DIR/test_39_file $DIR/test_39_file2
1192         [ $DIR/test_39_file2 -nt $DIR/test_39_file ] || error
1193 }
1194 run_test 39 "mtime changed on create ==========================="
1195
1196 test_40() {
1197         dd if=/dev/zero of=$DIR/f40 bs=4096 count=1
1198         $RUNAS $OPENFILE -f O_WRONLY:O_TRUNC $DIR/f40 && error
1199         $CHECKSTAT -t file -s 4096 $DIR/f40 || error
1200 }
1201 run_test 40 "failed open(O_TRUNC) doesn't truncate ============="
1202
1203 test_41() {
1204         # bug 1553
1205         small_write $DIR/f41 18
1206 }
1207 run_test 41 "test small file write + fstat ====================="
1208
1209 count_ost_writes() {
1210         cat /proc/fs/lustre/osc/*/stats |
1211             awk -vwrites=0 '/ost_write/ { writes += $2 } END { print writes; }'
1212 }
1213 start_kupdated() {
1214         # in 2.6, restore /proc/sys/vm/dirty_writeback_centisecs
1215         kill -CONT `pidof kupdated`
1216 }
1217 stop_kupdated() {
1218         # in 2.6, save and 0 /proc/sys/vm/dirty_writeback_centisecs
1219         kill -STOP `pidof kupdated`
1220         trap start_kupdated EXIT
1221 }
1222
1223 # Tests 42* verify that our behaviour is correct WRT caching, file closure,
1224 # file truncation, and file removal.
1225 test_42a() {
1226         cancel_lru_locks OSC
1227         stop_kupdated
1228         sync # just to be safe
1229         BEFOREWRITES=`count_ost_writes`
1230         dd if=/dev/zero of=$DIR/f42a bs=1024 count=100
1231         AFTERWRITES=`count_ost_writes`
1232         [ $BEFOREWRITES -eq $AFTERWRITES ] || \
1233                 error "$BEFOREWRITES < $AFTERWRITES"
1234         start_kupdated
1235 }
1236 run_test 42a "ensure that we don't flush on close =============="
1237
1238 test_42b() {
1239         cancel_lru_locks OSC
1240         stop_kupdated
1241         sync
1242         dd if=/dev/zero of=$DIR/f42b bs=1024 count=100
1243         BEFOREWRITES=`count_ost_writes`
1244         $MUNLINK $DIR/f42b || error "$MUNLINK $DIR/f42b: $?"
1245         AFTERWRITES=`count_ost_writes`
1246         [ $BEFOREWRITES -eq $AFTERWRITES ] ||
1247             error "$BEFOREWRITES < $AFTERWRITES on unlink"
1248         BEFOREWRITES=`count_ost_writes`
1249         sync || error "sync: $?"
1250         AFTERWRITES=`count_ost_writes`
1251         [ $BEFOREWRITES -eq $AFTERWRITES ] ||
1252             error "$BEFOREWRITES < $AFTERWRITES on sync"
1253         dmesg | grep 'error from obd_brw_async' && error 'error writing back'
1254         start_kupdated
1255         return 0
1256 }
1257 run_test 42b "test destroy of file with cached dirty data ======"
1258
1259 # if these tests just want to test the effect of truncation,
1260 # they have to be very careful.  consider:
1261 # - the first open gets a {0,EOF}PR lock
1262 # - the first write conflicts and gets a {0, count-1}PW
1263 # - the rest of the writes are under {count,EOF}PW
1264 # - the open for truncate tries to match a {0,EOF}PR
1265 #   for the filesize and cancels the PWs.
1266 # any number of fixes (don't get {0,EOF} on open, match
1267 # composite locks, do smarter file size management) fix
1268 # this, but for now we want these tests to verify that
1269 # the cancelation with truncate intent works, so we
1270 # start the file with a full-file pw lock to match against
1271 # until the truncate.
1272 trunc_test() {
1273         test=$1
1274         file=$DIR/$test
1275         offset=$2
1276         cancel_lru_locks OSC
1277         stop_kupdated
1278         # prime the file with 0,EOF PW to match
1279         touch $file
1280         $TRUNCATE $file 0
1281         sync; sync
1282         # now the real test..
1283         dd if=/dev/zero of=$file bs=1024 count=100
1284         BEFOREWRITES=`count_ost_writes`
1285         $TRUNCATE $file $offset
1286         cancel_lru_locks OSC
1287         AFTERWRITES=`count_ost_writes`
1288         start_kupdated
1289 }
1290
1291 test_42c() {
1292         trunc_test 42c 1024
1293         [ $BEFOREWRITES -eq $AFTERWRITES ] && \
1294             error "$BEFOREWRITES < $AFTERWRITES on truncate"
1295         rm $file
1296 }
1297 run_test 42c "test partial truncate of file with cached dirty data ===="
1298
1299 test_42d() {
1300         trunc_test 42d 0
1301         [ $BEFOREWRITES -eq $AFTERWRITES ] || \
1302             error "beforewrites $BEFOREWRITES != afterwrites $AFTERWRITES on truncate"
1303         rm $file
1304 }
1305 run_test 42d "test complete truncate of file with cached dirty data ===="
1306
1307 test_43() {
1308         mkdir $DIR/d43
1309         cp -p /bin/ls $DIR/d43/f
1310         exec 100>> $DIR/d43/f   
1311         $DIR/d43/f && error || true
1312         exec 100<&-
1313 }
1314 run_test 43 "execution of file opened for write should return -ETXTBSY=="
1315
1316 test_43a() {
1317         mkdir -p $DIR/d43
1318         cp -p `which multiop` $DIR/d43/multiop
1319         touch $DIR/d43/g
1320         $DIR/d43/multiop $DIR/d43/g o_c &
1321         MULTIPID=$!
1322         sleep 1
1323         multiop $DIR/d43/multiop Oc && error "expected error, got success"
1324         kill -USR1 $MULTIPID || return 2
1325         wait $MULTIPID || return 3
1326 }
1327 run_test 43a "open(RDWR) of file being executed should return -ETXTBSY=="
1328
1329 test_43b() {
1330         mkdir -p $DIR/d43
1331         cp -p `which multiop` $DIR/d43/multiop
1332         touch $DIR/d43/g
1333         $DIR/d43/multiop $DIR/d43/g o_c &
1334         MULTIPID=$!
1335         sleep 1
1336         truncate $DIR/d43/multiop 0 && error "expected error, got success"
1337         kill -USR1 $MULTIPID || return 2
1338         wait $MULTIPID || return 3
1339 }
1340 run_test 43b "truncate of file being executed should return -ETXTBSY===="
1341
1342 test_43c() {
1343         local testdir="$DIR/d43c"
1344         mkdir -p $testdir
1345         cp $SHELL $testdir/
1346         ( cd $(dirname $SHELL) && md5sum $(basename $SHELL) ) |  \
1347                 ( cd $testdir && md5sum -c)
1348 }
1349 run_test 43c "md5sum of copy into lustre================================"
1350
1351 test_44() {
1352         [  "$STRIPECOUNT" -lt "2" ] && echo "skipping 2-stripe test" && return
1353         dd if=/dev/zero of=$DIR/f1 bs=4k count=1 seek=127
1354         dd if=$DIR/f1 bs=4k count=1
1355 }
1356 run_test 44 "zero length read from a sparse stripe ============="
1357
1358 test_44a() {
1359     local nstripe=`$LCTL lov_getconfig $DIR | grep default_stripe_count: | \
1360                          awk '{print $2}'`
1361     local stride=`$LCTL lov_getconfig $DIR | grep default_stripe_size: | \
1362                       awk '{print $2}'`
1363     if [ $nstripe -eq 0 ] ; then
1364         nstripe=`$LCTL lov_getconfig $DIR | grep obd_count: | awk '{print $2}'`
1365     fi
1366
1367     OFFSETS="0 $((stride/2)) $((stride-1))"
1368     for offset in $OFFSETS ; do
1369       for i in `seq 0 $((nstripe-1))`; do
1370         rm -f $DIR/d44a
1371         local GLOBALOFFSETS=""
1372         local size=$((((i + 2 * $nstripe )*$stride + $offset)))  # Bytes
1373         ll_sparseness_write $DIR/d44a $size  || error "ll_sparseness_write"
1374         GLOBALOFFSETS="$GLOBALOFFSETS $size"
1375         ll_sparseness_verify $DIR/d44a $GLOBALOFFSETS \
1376                             || error "ll_sparseness_verify $GLOBALOFFSETS"
1377
1378         for j in `seq 0 $((nstripe-1))`; do
1379             size=$((((j + $nstripe )*$stride + $offset)))  # Bytes
1380             ll_sparseness_write $DIR/d44a $size || error "ll_sparseness_write"
1381             GLOBALOFFSETS="$GLOBALOFFSETS $size"
1382         done
1383         ll_sparseness_verify $DIR/d44a $GLOBALOFFSETS \
1384                             || error "ll_sparseness_verify $GLOBALOFFSETS"
1385       done
1386     done
1387 }
1388 run_test 44a "test sparse pwrite ==============================="
1389
1390 dirty_osc_total() {
1391         tot=0
1392         for d in /proc/fs/lustre/osc/*/cur_dirty_bytes; do
1393                 tot=$(($tot + `cat $d`))
1394         done
1395         echo $tot
1396 }
1397 do_dirty_record() {
1398         before=`dirty_osc_total`
1399         echo executing "\"$*\""
1400         eval $*
1401         after=`dirty_osc_total`
1402         echo before $before, after $after
1403 }
1404 test_45() {
1405         f="$DIR/f45"
1406         stop_kupdated
1407         sync
1408         do_dirty_record "echo blah > $f"
1409         [ $before -eq $after ] && error "write wasn't cached"
1410         do_dirty_record "> $f"
1411         [ $before -gt $after ] || error "truncate didn't lower dirty count"
1412         do_dirty_record "echo blah > $f"
1413         [ $before -eq $after ] && error "write wasn't cached"
1414         do_dirty_record "sync"
1415         [ $before -gt $after ] || error "writeback didn't lower dirty count"
1416         do_dirty_record "echo blah > $f"
1417         [ $before -eq $after ] && error "write wasn't cached"
1418         do_dirty_record "cancel_lru_locks OSC"
1419         [ $before -gt $after ] || error "lock cancelation didn't lower dirty count"
1420         start_kupdated
1421 }
1422 run_test 45 "osc io page accounting ============================"
1423
1424 page_size() {
1425         getconf PAGE_SIZE
1426 }
1427
1428 # in a 2 stripe file (lov.sh), page 63 maps to page 31 in its object.  this
1429 # test tickles a bug where re-dirtying a page was failing to be mapped to the
1430 # objects offset and an assert hit when an rpc was built with 63's mapped 
1431 # offset 31 and 31's raw 31 offset. it also found general redirtying bugs.
1432 test_46() {
1433         f="$DIR/f46"
1434         stop_kupdated
1435         sync
1436         dd if=/dev/zero of=$f bs=`page_size` seek=31 count=1
1437         sync
1438         dd conv=notrunc if=/dev/zero of=$f bs=`page_size` seek=63 count=1
1439         dd conv=notrunc if=/dev/zero of=$f bs=`page_size` seek=31 count=1
1440         sync
1441         start_kupdated
1442 }
1443 run_test 46 "dirtying a previously written page ================"
1444
1445 # Check that device nodes are created and then visible correctly (#2091)
1446 test_47() {
1447         cmknod $DIR/test_47_node || error
1448 }
1449 run_test 47 "Device nodes check ================================"
1450
1451 test_48() {
1452         mkdir $DIR/d48
1453         cd $DIR/d48
1454         mv $DIR/d48 $DIR/d48.new || error "move directory failed"
1455         mkdir $DIR/d48 || error "recreate diectory failed"
1456         ls || error "can't list after recreate directory"
1457 }
1458 run_test 48 "Access renamed current working directory ========="
1459
1460 test_50() {
1461         # bug 1485
1462         mkdir $DIR/d50
1463         cd $DIR/d50
1464         ls /proc/$$/cwd || error
1465 }
1466 run_test 50 "special situations: /proc symlinks  ==============="
1467
1468 test_51() {
1469         # bug 1516 - create an empty entry right after ".." then split dir
1470         mkdir $DIR/d49
1471         touch $DIR/d49/foo
1472         $MCREATE $DIR/d49/bar
1473         rm $DIR/d49/foo
1474         createmany -m $DIR/d49/longfile 201
1475         FNUM=202
1476         while [ `ls -sd $DIR/d49 | awk '{ print $1 }'` -eq 4 ]; do
1477                 $MCREATE $DIR/d49/longfile$FNUM
1478                 FNUM=$(($FNUM + 1))
1479                 echo -n "+"
1480         done
1481         ls -l $DIR/d49 > /dev/null || error
1482 }
1483 run_test 51 "special situations: split htree with empty entry =="
1484
1485 test_52a() {
1486         [ -f $DIR/d52a/foo ] && chattr -a $DIR/d52a/foo
1487         mkdir -p $DIR/d52a
1488         touch $DIR/d52a/foo
1489         chattr =a $DIR/d52a/foo || error
1490         echo bar >> $DIR/d52a/foo || error
1491         cp /etc/hosts $DIR/d52a/foo && error
1492         rm -f $DIR/d52a/foo 2>/dev/null && error
1493         link $DIR/d52a/foo $DIR/d52a/foo_link 2>/dev/null && error
1494         echo foo >> $DIR/d52a/foo || error
1495         mrename $DIR/d52a/foo $DIR/d52a/foo_ren && error
1496         lsattr $DIR/d52a/foo | egrep -q "^-+a-+ $DIR/d52a/foo" || error
1497         chattr -a $DIR/d52a/foo || error
1498
1499         rm -fr $DIR/d52a || error
1500 }
1501 run_test 52a "append-only flag test (should return errors) ====="
1502
1503 test_52b() {
1504         [ -f $DIR/d52b/foo ] && chattr -i $DIR/d52b/foo
1505         mkdir -p $DIR/d52b
1506         touch $DIR/d52b/foo
1507         chattr =i $DIR/d52b/foo || error
1508         cat test > $DIR/d52b/foo && error
1509         cp /etc/hosts $DIR/d52b/foo && error
1510         rm -f $DIR/d52b/foo 2>/dev/null && error
1511         link $DIR/d52b/foo $DIR/d52b/foo_link 2>/dev/null && error
1512         echo foo >> $DIR/d52b/foo && error
1513         mrename $DIR/d52b/foo $DIR/d52b/foo_ren && error
1514         [ -f $DIR/d52b/foo ] || error
1515         [ -f $DIR/d52b/foo_ren ] && error
1516         lsattr $DIR/d52b/foo | egrep -q "^-+i-+ $DIR/d52b/foo" || error
1517         chattr -i $DIR/d52b/foo || error
1518
1519         rm -fr $DIR/d52b || error
1520 }
1521 run_test 52b "immutable flag test (should return errors) ======="
1522
1523 test_53() {
1524         for i in /proc/fs/lustre/osc/OSC*mds1 ; do
1525                 ostname=`echo $i | cut -d _ -f 3-4 | sed -e s/_mds1//`
1526                 ost_last=`cat /proc/fs/lustre/obdfilter/$ostname/last_id`
1527                 mds_last=`cat $i/prealloc_last_id`
1528                 echo "$ostname.last_id=$ost_last ; MDS.last_id=$mds_last"
1529                 if [ $ost_last != $mds_last ]; then
1530                     error "$ostname.last_id=$ost_last ; MDS.last_id=$mds_last"
1531                 fi
1532         done
1533 }
1534 run_test 53 "verify that MDS and OSTs agree on pre-creation ===="
1535
1536 test_54() {
1537         $SOCKETSERVER $DIR/socket &
1538         sleep 1
1539         $SOCKETCLIENT $DIR/socket || error
1540         $MUNLINK $DIR/socket
1541 }
1542 run_test 54 "unix damain socket test ==========================="
1543
1544 test_55() {
1545         rm -rf $DIR/d55
1546         mkdir $DIR/d55
1547         mount -t ext3 -o loop,iopen $EXT3_DEV $DIR/d55 || error
1548         touch $DIR/d55/foo
1549         $IOPENTEST1 $DIR/d55/foo $DIR/d55 || error
1550         $IOPENTEST2 $DIR/d55 || error
1551         echo "check for $EXT3_DEV. Please wait..."
1552         rm -rf $DIR/d55/*
1553         umount $DIR/d55 || error
1554 }
1555 run_test 55 "check iopen_connect_dentry()======================="
1556
1557 test_56() {
1558         rm -rf $DIR/d56
1559         mkdir $DIR/d56
1560         mkdir $DIR/d56/dir
1561         NUMFILES=3
1562         NUMFILESx2=$(($NUMFILES * 2))
1563         for i in `seq 1 $NUMFILES` ; do
1564                 touch $DIR/d56/file$i
1565                 touch $DIR/d56/dir/file$i
1566         done
1567
1568         # test lfs find with --recursive
1569         FILENUM=`$LFIND --recursive $DIR/d56 | grep -c obdidx`
1570         [ $FILENUM -eq $NUMFILESx2 ] || error \
1571                 "lfs find --recursive $DIR/d56 wrong: found $FILENUM, expected $NUMFILESx2"
1572         FILENUM=`$LFIND $DIR/d56 | grep -c obdidx`
1573         [ $FILENUM -eq $NUMFILES ] || error \
1574                 "lfs find $DIR/d56 without --recursive wrong: found $FILENUM,
1575                 expected $NUMFILES"
1576         echo "lfs find --recursive passed."
1577
1578         # test lfs find with file instead of dir
1579         FILENUM=`$LFIND $DIR/d56/file1 | grep -c obdidx`
1580         [ $FILENUM  -eq 1 ] || error \
1581                  "lfs find $DIR/d56/file1 wrong:found $FILENUM, expected 1"
1582         echo "lfs find file passed."
1583
1584         #test lfs find with --verbose
1585         [ `$LFIND --verbose $DIR/d56 | grep -c lmm_magic` -eq $NUMFILES ] ||\
1586                 error "lfs find --verbose $DIR/d56 wrong: should find $NUMFILES lmm_magic info"
1587         [ `$LFIND $DIR/d56 | grep -c lmm_magic` -eq 0 ] || error \
1588                 "lfs find $DIR/d56 without --verbose wrong: should not show lmm_magic info"
1589         echo "lfs find --verbose passed."
1590
1591         #test lfs find with --obd
1592         $LFIND --obd wrong_uuid $DIR/d56 2>&1 | grep -q "unknown obduuid" || \
1593                 error "lfs find --obd wrong_uuid should return error information"
1594
1595         [  "$STRIPECOUNT" -lt 2 ] && \
1596                 echo "skipping other lfs find --obd test" && return
1597         FILENUM=`$LFIND --recursive $DIR/d56 | sed -n '/^[       ]*1[    ]/p' | wc -l`
1598         OBDUUID=`$LFIND --recursive $DIR/d56 | sed -n '/^[       ]*1:/p' | awk '{print $2}'`
1599         FOUND=`$LFIND -r --obd $OBDUUID $DIR/d56 | wc -l`
1600         [ $FOUND -eq $FILENUM ] || \
1601                 error "lfs find --obd wrong: found $FOUND, expected $FILENUM"
1602         [ `$LFIND -r -v --obd $OBDUUID $DIR/d56 | sed '/^[       ]*1[    ]/d' | \
1603                 sed -n '/^[      ]*[0-9][0-9]*[  ]/p' | wc -l` -eq 0 ] || \
1604                 error "lfs find --obd wrong: should not show file on other obd"
1605         echo "lfs find --obd passed."
1606 }
1607 run_test 56 "check lfs find====================================="
1608
1609 test_59() {
1610         echo "touch 130 files"
1611         for i in `seq 1 130` ; do
1612                 touch $DIR/59-$i
1613         done
1614         echo "rm 130 files"
1615         for i in `seq 1 130` ; do
1616                 rm -f $DIR/59-$i
1617         done
1618         sync
1619         sleep 2
1620         # wait for commitment of removal
1621 }
1622 run_test 59 "verify cancellation of llog records async ========="
1623
1624 test_60() {
1625         echo 60 "llog tests run from kernel mode"
1626         sh run-llog.sh
1627 }
1628 run_test 60 "llog sanity tests run from kernel module =========="
1629
1630 test_61() {
1631         f="$DIR/f61"
1632         dd if=/dev/zero of=$f bs=`page_size` count=1
1633         cancel_lru_locks OSC
1634         multiop $f OSMWUc || error
1635         sync
1636 }
1637 run_test 61 "mmap() writes don't make sync hang =========="
1638
1639 # bug 2330 - insufficient obd_match error checking causes LBUG
1640 test_62() {
1641         f="$DIR/f62"
1642         echo foo > $f
1643         cancel_lru_locks OSC
1644         echo 0x405 > /proc/sys/lustre/fail_loc
1645         cat $f && error # expect -EIO
1646         multiop $f Owc && error
1647         echo 0 > /proc/sys/lustre/fail_loc
1648 }
1649 run_test 62 "verify obd_match failure doesn't LBUG (should -EIO)"
1650
1651 # bug 2319 - osic_wait() interrupted causes crash because of invalid waitq.
1652 test_63() {
1653         MAX_DIRTY_MB=`cat /proc/fs/lustre/osc/*/max_dirty_mb | head -1`
1654         for i in /proc/fs/lustre/osc/*/max_dirty_mb ; do
1655                 echo 0 > $i
1656         done
1657         for i in `seq 10` ; do
1658                 dd if=/dev/zero of=$DIR/f63 bs=8k &
1659                 sleep 5
1660                 kill $!
1661                 sleep 1
1662         done
1663
1664         for i in /proc/fs/lustre/osc/*/max_dirty_mb ; do
1665                 echo $MAX_DIRTY_MB > $i
1666         done
1667         true
1668 }
1669 run_test 63 "Verify osic_wait interruption does not crash ======"
1670
1671 # on the LLNL clusters, runas will still pick up root's $TMP settings,
1672 # which will not be writable for the runas user, and then you get a CVS
1673 # error message with a corrupt path string (CVS bug) and panic.
1674 # We're not using much space, so just stick it in /tmp, which is safe.
1675 OLDTMPDIR=$TMPDIR
1676 OLDTMP=$TMP
1677 TMPDIR=/tmp
1678 TMP=/tmp
1679 OLDHOME=$HOME
1680 [ $RUNAS_ID -ne $UID ] && HOME=/tmp
1681
1682 test_99a() {
1683         mkdir -p $DIR/d99cvsroot
1684         chown $RUNAS_ID $DIR/d99cvsroot
1685         $RUNAS cvs -d $DIR/d99cvsroot init || error
1686 }
1687 run_test 99a "cvs init ========================================="
1688
1689 test_99b() {
1690         [ ! -d $DIR/d99cvsroot ] && run_one 99a
1691         cd /etc/init.d
1692         $RUNAS cvs -d $DIR/d99cvsroot import -m "nomesg" d99reposname vtag rtag
1693 }
1694 run_test 99b "cvs import ======================================="
1695
1696 test_99c() {
1697         [ ! -d $DIR/d99cvsroot ] && run_one 99b
1698         cd $DIR
1699         mkdir -p $DIR/d99reposname
1700         chown $RUNAS_ID $DIR/d99reposname
1701         $RUNAS cvs -d $DIR/d99cvsroot co d99reposname
1702 }
1703 run_test 99c "cvs checkout ====================================="
1704
1705 test_99d() {
1706         [ ! -d $DIR/d99cvsroot ] && run_one 99c
1707         cd $DIR/d99reposname
1708         $RUNAS touch foo99
1709         $RUNAS cvs add -m 'addmsg' foo99
1710 }
1711 run_test 99d "cvs add =========================================="
1712
1713 test_99e() {
1714         [ ! -d $DIR/d99cvsroot ] && run_one 99c
1715         cd $DIR/d99reposname
1716         $RUNAS cvs update
1717 }
1718 run_test 99e "cvs update ======================================="
1719
1720 test_99f() {
1721         [ ! -d $DIR/d99cvsroot ] && run_one 99d
1722         cd $DIR/d99reposname
1723         $RUNAS cvs commit -m 'nomsg' foo99
1724 }
1725 run_test 99f "cvs commit ======================================="
1726
1727 TMPDIR=$OLDTMPDIR
1728 TMP=$OLDTMP
1729 HOME=$OLDHOME
1730
1731 log "cleanup: ======================================================"
1732 if [ "`mount | grep ^$NAME`" ]; then
1733         rm -rf $DIR/[Rdfs][1-9]*
1734         if [ "$I_MOUNTED" = "yes" ]; then
1735                 sh llmountcleanup.sh || error
1736         fi
1737 fi
1738
1739 echo '=========================== finished ==============================='
1740 [ -f "$SANITYLOG" ] && cat $SANITYLOG && exit 1 || true